/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2007-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: sh7750r.h 2114 2011-06-22 02:07:06Z ertl-honda $
 */

/*
 *  SH7750RΥϡɥ񸻤
 */

#ifndef TOPPERS_SH7750R_H
#define TOPPERS_SH7750R_H

#include <sil.h>

/*
 *  㳰٥ȥ쥸
 */
#define TRA         0xff000020
#define EXPEVT      0xff000024
#define INTEVT      0xff000028

/*
 *  ߤˤä INTEVT 쥸ꤵ
 */
#define NMI_INTEVT          UINT_C(0x1c0)
#define IRL0_INTEVT         UINT_C(0x200)
#define IRL1_INTEVT         UINT_C(0x220)
#define IRL2_INTEVT         UINT_C(0x240)
#define IRL3_INTEVT         UINT_C(0x260)
#define IRL4_INTEVT         UINT_C(0x280)
#define IRL5_INTEVT         UINT_C(0x2a0)
#define IRL6_INTEVT         UINT_C(0x2c0)
#define IRL7_INTEVT         UINT_C(0x2e0)
#define IRL8_INTEVT         UINT_C(0x300)
#define IRL9_INTEVT         UINT_C(0x320)
#define IRLA_INTEVT         UINT_C(0x340)
#define IRLB_INTEVT         UINT_C(0x360)
#define IRLC_INTEVT         UINT_C(0x380)
#define IRLD_INTEVT         UINT_C(0x3a0)
#define IRLE_INTEVT         UINT_C(0x3c0)
#define TMU0_INTEVT         UINT_C(0x400)
#define TMU1_INTEVT         UINT_C(0x420)
#define TMU2_INTEVT         UINT_C(0x440)
#define TMU3_INTEVT         UINT_C(0xB00)
#define TMU4_INTEVT         UINT_C(0xB80)
#define SCI_RXI_INTEVT      UINT_C(0x500)
#define SCI_TXI_INTEVT      UINT_C(0x520)
#define SCI_TEI_INTEVT      UINT_C(0x540)
#define SCIF_RXI_INTEVT     UINT_C(0x720)
#define SCIF_TXI_INTEVT     UINT_C(0x760)
#define SCIF_BRI_INTEVT     UINT_C(0x740)

/*
 *  ߥȥ쥸
 */
#define ICR      UINT_C(0xFFD00000) /* H */
#define IPRA     UINT_C(0xFFD00004) /* H */
#define IPRB     UINT_C(0xFFD00008) /* H */
#define IPRC     UINT_C(0xFFD0000C) /* H */
#define IPRD     UINT_C(0xFFD00010) /* H */

#define INTPRI00 UINT_C(0xFE080000) /* W */
#define INTREQ   UINT_C(0xFE080020) /* W */
#define INTMSK00 UINT_C(0xFE080040) /* W */
#define INTMSKCR UINT_C(0xFE080060) /* W */

/*
 * ޡ쥸
 */
#define TMU_TOCR   UINT_C(0xFFD80000)  /* B */
#define TMU_TSTR   UINT_C(0xFFD80004)  /* B */
#define TMU_TSTR2  UINT_C(0xFE100004)  /* B */
#define TMU_TCOR0  UINT_C(0xFFD80008)  /* W */
#define TMU_TCNT0  UINT_C(0xFFD8000C)  /* W */
#define TMU_TCR0   UINT_C(0xFFD80010)  /* H */
#define TMU_TCOR1  UINT_C(0xFFD80014)  /* W */
#define TMU_TCNT1  UINT_C(0xFFD80018)  /* W */
#define TMU_TCR1   UINT_C(0xFFD8001C)  /* H */
#define TMU_TCOR2  UINT_C(0xFFD80020)  /* W */
#define TMU_TCNT2  UINT_C(0xFFD80024)  /* W */
#define TMU_TCR2   UINT_C(0xFFD80028)  /* H */
#define TMU_TCOR3  UINT_C(0xFE100008)  /* W */
#define TMU_TCNT3  UINT_C(0xFE10000C)  /* W */
#define TMU_TCR3   UINT_C(0xFE100010)  /* H */
#define TMU_TCOR4  UINT_C(0xFE100014)  /* W */
#define TMU_TCNT4  UINT_C(0xFE100018)  /* W */
#define TMU_TCR4   UINT_C(0xFE10001C)  /* H */

#define TMU_STR0   UINT_C(0x01)
#define TMU_STR1   UINT_C(0x02)
#define TMU_STR2   UINT_C(0x04)
#define TMU_STR3   UINT_C(0x01)
#define TMU_STR4   UINT_C(0x02)
#define TCR_UNF    UINT_C(0x0100)
#define TCR_UNIE   UINT_C(0x0020)

/*
 *	 ХơȥȥϢ
 */
#define BCR1       UINT_C(0xFF800000)  /* W */
#define BCR2       UINT_C(0xFF800004)  /* H */
#define BCR3       UINT_C(0xFF800050)  /* H */
#define BCR4       UINT_C(0xFE0A00F0)  /* W */
#define WCR1       UINT_C(0xFF800008)  /* W */
#define WCR2       UINT_C(0xFF80000C)  /* W */
#define WCR3       UINT_C(0xFF800010)  /* W */
#define MCR        UINT_C(0xFF800014)  /* W */
#define PCR        UINT_C(0xFF800018)  /* H */
#define RTCSR      UINT_C(0xFF80001C)  /* H */
#define RTCNT      UINT_C(0xFF800020)  /* H */
#define RTCOR      UINT_C(0xFF800024)  /* H */
#define RFCR       UINT_C(0xFF800028)  /* H */
/* #define SDMR2      UINT_C(0xFF90xxxx) */ /* B */
/* #define SDMR3      UINT_C(0xFF94xxxx) */ /* B */

/*
 *  FIFOդꥢ륳ߥ˥󥤥󥿡ե(SCIF)쥸
 */
#define SH_SCIF0_BASE UINT_C(0xFFE80000)

/*
 *  ꥢ륳ߥ˥󥤥󥿡ե(SCI)
 */
#define SCI_SCSMR1    UINT_C(0xFFE00000)  /* B */
#define SCI_SCBRR1    UINT_C(0xFFE00004)  /* B */
#define SCI_SCSCR1    UINT_C(0xFFE00008)  /* B */
#define SCI_SCTDR1    UINT_C(0xFFE0000C)  /* B */
#define SCI_SCSSR1    UINT_C(0xFFE00010)  /* B */
#define SCI_SCRDR1    UINT_C(0xFFE00014)  /* B */
#define SCI_SCSPTR1   UINT_C(0xFFE0001C)  /* B */


/*
 *  å쥸
 */
#define CCR           UINT_C(0xFF00001C)   /* W */
#define CCR_DISABLE   UINT_C(0x00000808)  /* å̵ */

/*
 * IRQֹξ¤Ȳ
 */
#define TMIN_IRQNO   0x200
#define TMAX_IRQNO   0x3C0

#endif /* TOPPERS_SH7750R_H */
