/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 */

#ifndef TOPPERS_TARGET_SVC_H
#define TOPPERS_TARGET_SVC_H

#ifndef TOPPERS_MACRO_ONLY


/*
 *  ͥΥӥΥ󥿥ե
 *
 *  å쥸
 *    r1 : ؿ
 *    r4 - r7 : 4Ĥޤǡ
 *    r2 : 5
 *  ؿƤӽФ(jsr)ǥӥƤӽФᡤPR¸
 */
extern char _kernel_svc_entry;

#define CAL_SVC_0(TYPE, FNCD) \
	register TYPE  r0 asm("r0"); \
	register FN    r1 asm("r1") = FNCD; \
	Asm ( \
        "trapa #1\n\t" \
        "nop\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
		:"=r"(r0),"+r"(r1) \
		:"r"(r1)\
		:"pr","r2","r3","r4","r5","r6","r7","mach","macl" \
	); \
	return(r0);

#define CAL_SVC_1(TYPE, FNCD, TYPE1, PAR1) \
	register TYPE  r0 asm("r0"); \
	register TYPE1 r4 asm("r4") = (TYPE1)(PAR1); \
	register FN    r1 asm("r1") = FNCD; \
	Asm ( \
        "trapa #1\n\t" \
        "nop\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
		:"=r"(r0),"+r"(r1),"+r"(r4) \
		:"r"(r1),"r"(r4)\
		:"pr","r2","r3","r5","r6","r7","mach","macl" \
	); \
	return(r0);

#define CAL_SVC_2(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2) \
	register TYPE  r0 asm("r0"); \
	register TYPE1 r4 asm("r4") = (TYPE1)(PAR1); \
	register TYPE2 r5 asm("r5") = (TYPE2)(PAR2); \
	register FN    r1 asm("r1") = FNCD; \
	Asm ( \
        "trapa #1\n\t" \
        "nop\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
		:"=r"(r0),"+r"(r1),"+r"(r4),"+r"(r5) \
		:"r"(r1),"r"(r4),"r"(r5)\
		:"pr","r2","r3","r6","r7","mach","macl" \
	); \
	return(r0);

#define CAL_SVC_3(TYPE, FNCD, TYPE1, PAR1, \
							TYPE2, PAR2, TYPE3, PAR3) \
	register TYPE  r0 asm("r0"); \
	register TYPE1 r4 asm("r4") = (TYPE1)(PAR1); \
	register TYPE2 r5 asm("r5") = (TYPE2)(PAR2); \
	register TYPE3 r6 asm("r6") = (TYPE3)(PAR3); \
	register FN    r1 asm("r1") = FNCD; \
	Asm ( \
        "trapa #1\n\t" \
        "nop\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
		:"=r"(r0),"+r"(r1),"+r"(r4),"+r"(r5),"+r"(r6) \
		:"r"(r1),"r"(r4),"r"(r5),"r"(r6)\
		:"pr","r2","r3","r7","mach","macl" \
	); \
	return(r0);

#define CAL_SVC_4(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2, \
								TYPE3, PAR3, TYPE4, PAR4) \
	register TYPE  r0 asm("r0"); \
	register TYPE1 r4 asm("r4") = (TYPE1)(PAR1); \
	register TYPE2 r5 asm("r5") = (TYPE2)(PAR2); \
	register TYPE3 r6 asm("r6") = (TYPE3)(PAR3); \
	register TYPE4 r7 asm("r7") = (TYPE4)(PAR4); \
	register FN    r1 asm("r1") = FNCD; \
	Asm ( \
        "trapa #1\n\t" \
        "nop\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
		:"=r"(r0),"+r"(r1),"+r"(r4),"+r"(r5),"+r"(r6),"+r"(r7) \
		:"r"(r1),"r"(r4),"r"(r5),"r"(r6),"r"(r7)\
		:"pr","r2","r3","mach","macl" \
	); \
	return(r0);

#define CAL_SVC_5(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2, \
						TYPE3, PAR3, TYPE4, PAR4, TYPE5, PAR5) \
	register TYPE  r0 asm("r0"); \
	register TYPE1 r4 asm("r4") = (TYPE1)(PAR1); \
	register TYPE2 r5 asm("r5") = (TYPE2)(PAR2); \
	register TYPE3 r6 asm("r6") = (TYPE3)(PAR3); \
	register TYPE4 r7 asm("r7") = (TYPE4)(PAR4); \
	register TYPE5 r2 asm("r2") = (TYPE5)(PAR5); \
	register FN    r1 asm("r1") = FNCD; \
	Asm ( \
        "trapa #1\n\t" \
        "nop\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
		:"=r"(r0),"+r"(r1),"+r"(r2),"+r"(r4),"+r"(r5),"+r"(r6),"+r"(r7) \
		:"r"(r1),"r"(r2),"r"(r4),"r"(r5),"r"(r6),"r"(r7) \
		:"pr","r3","mach","macl" \
	); \
	return(r0);

#define CAL_SVC_0M(TYPE, FNCD) \
	register TYPE  r0 asm("r0"); \
	register FN    r1 asm("r1") = FNCD; \
	Asm ( \
        "trapa #1\n\t" \
        "nop\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
		:"=r"(r0),"+r"(r1) \
		:"r"(r1)\
		:"memory","pr","r2","r3","r4","r5","r6","r7","mach","macl" \
	); \
	return(r0);

#define CAL_SVC_1M(TYPE, FNCD, TYPE1, PAR1) \
	register TYPE  r0 asm("r0"); \
	register TYPE1 r4 asm("r4") = (TYPE1)(PAR1); \
	register FN    r1 asm("r1") = FNCD; \
	Asm ( \
        "trapa #1\n\t" \
        "nop\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
		:"=r"(r0),"+r"(r1),"+r"(r4) \
		:"r"(r1),"r"(r4)\
		:"memory","pr","r2","r3","r5","r6","r7","mach","macl" \
	); \
	return(r0);

#define CAL_SVC_2M(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2) \
	register TYPE  r0 asm("r0"); \
	register TYPE1 r4 asm("r4") = (TYPE1)(PAR1); \
	register TYPE2 r5 asm("r5") = (TYPE2)(PAR2); \
	register FN    r1 asm("r1") = FNCD; \
	Asm ( \
        "trapa #1\n\t" \
        "nop\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
		:"=r"(r0),"+r"(r1),"+r"(r4),"+r"(r5) \
		:"r"(r1),"r"(r4),"r"(r5)\
		:"memory","pr","r2","r3","r6","r7","mach","macl" \
	); \
	return(r0);

#define CAL_SVC_3M(TYPE, FNCD, TYPE1, PAR1, \
							TYPE2, PAR2, TYPE3, PAR3) \
	register TYPE  r0 asm("r0"); \
	register TYPE1 r4 asm("r4") = (TYPE1)(PAR1); \
	register TYPE2 r5 asm("r5") = (TYPE2)(PAR2); \
	register TYPE3 r6 asm("r6") = (TYPE3)(PAR3); \
	register FN    r1 asm("r1") = FNCD; \
	Asm ( \
        "trapa #1\n\t" \
        "nop\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
		:"=r"(r0),"+r"(r1),"+r"(r4),"+r"(r5),"+r"(r6) \
		:"r"(r1),"r"(r4),"r"(r5),"r"(r6)\
		:"memory","pr","r2","r3","r7","mach","macl" \
	); \
	return(r0);

#define CAL_SVC_4M(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2, \
								TYPE3, PAR3, TYPE4, PAR4) \
	register TYPE  r0 asm("r0"); \
	register TYPE1 r4 asm("r4") = (TYPE1)(PAR1); \
	register TYPE2 r5 asm("r5") = (TYPE2)(PAR2); \
	register TYPE3 r6 asm("r6") = (TYPE3)(PAR3); \
	register TYPE4 r7 asm("r7") = (TYPE4)(PAR4); \
	register FN    r1 asm("r1") = FNCD; \
	Asm ( \
        "trapa #1\n\t" \
        "nop\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
		:"=r"(r0),"+r"(r1),"+r"(r4),"+r"(r5),"+r"(r6),"+r"(r7) \
		:"r"(r1),"r"(r4),"r"(r5),"r"(r6),"r"(r7)\
		:"memory","pr","r2","r3","mach","macl" \
	); \
	return(r0);

#define CAL_SVC_5M(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2, \
						TYPE3, PAR3, TYPE4, PAR4, TYPE5, PAR5) \
	register TYPE  r0 asm("r0"); \
	register TYPE1 r4 asm("r4") = (TYPE1)(PAR1); \
	register TYPE2 r5 asm("r5") = (TYPE2)(PAR2); \
	register TYPE3 r6 asm("r6") = (TYPE3)(PAR3); \
	register TYPE4 r7 asm("r7") = (TYPE4)(PAR4); \
	register TYPE5 r2 asm("r2") = (TYPE5)(PAR5); \
	register FN    r1 asm("r1") = FNCD; \
	Asm ( \
        "trapa #1\n\t" \
        "nop\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
        "or r0, r0\n\t" \
		:"=r"(r0),"+r"(r1),"+r"(r2),"+r"(r4),"+r"(r5),"+r"(r6),"+r"(r7) \
		:"r"(r1),"r"(r2),"r"(r4),"r"(r5),"r"(r6),"r"(r7) \
		:"memory","pr","r3","mach","macl" \
	); \
	return(r0);

#ifndef TOPPERS_SVC_CALL
#include "gcc/tool_svc.h"
#endif /* TOPPERS_SVC_CALL */

Inline ER_UINT
cal_svc(FN fncd, intptr_t par1, intptr_t par2,
        intptr_t par3, intptr_t par4, intptr_t par5)
{
    if(fncd > 0){
        CAL_SVC_5M(FN, fncd, intptr_t, par1, intptr_t, par2, 
                intptr_t, par3, intptr_t, par4, intptr_t, par5);
    } else {
        return (E_RSFN);
    }
}

#endif /* TOPPERS_MACRO_ONLY */


#endif /* TOPPERS_TARGET_SVC_H */

