/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_timer.c 2106 2011-06-21 13:46:09Z ertl-honda $
 */

/*
 *  ޥɥ饤СSH34ѡ
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "target_timer.h"
#ifdef TRACE_ENABLE
#endif /* TRACE_ENABLE */

#ifdef TOPPERS_TARGET_SUPPORT_OVRHDR
/*
 *	Х󥿥ޤν
 *
 *	ޤ롥
 */
void
target_ovrtimer_initialize(intptr_t exinf)
{
	/*
	 *	޼ꤹ롥
	 */
    sil_wrb_mem((void*)TMU_TSTR,
                (sil_reb_mem((void*)TMU_TSTR) & ~TMU_STR1));  /*  */

    /* ʬꡢߵ */
    sil_wrh_mem((void*)TMU_TCR1,(0x020 | TCR0_TPSC));
    
}

/*
 *	Х󥿥ޤνλ
 *
 *	ޤưλ롥
 */
void
target_ovrtimer_terminate(intptr_t exinf)
{
    /* ޤ */
    sil_wrb_mem((void*)TMU_TSTR,
                (sil_reb_mem((void*)TMU_TSTR) & ~TMU_STR1));
    /* ׵򥯥ꥢ */
    sil_wrh_mem((void*)TMU_TCR1,0);

}

/*
 *	Х󥿥ޤεư
 *
 *	ޤư롥
 */
void
target_ovrtimer_start(OVRTIM ovrtim)
{
	CLOCK	 cyc = OVRTIMER_CLOCK(ovrtim) - 1;

    /*
     *  ޼ꤷޤư򳫻Ϥ롥
     */
    assert(cyc <= MAX_CLOCK);             /* ޾ͤΥå */

    sil_wrw_mem((void*)TMU_TCOR1, cyc); /* timer constant쥸򥻥å */
    sil_wrw_mem((void*)TMU_TCNT1, cyc); /* 󥿡򥻥å */

    /* ׵򥯥ꥢ */
    sil_wrh_mem((void*)TMU_TCR1,
                (sil_reh_mem((void*)TMU_TCR1) & ~TCR_UNF));

    /* 1 */
    sil_wrb_mem((void*)TMU_TSTR,
                (sil_reb_mem((void*)TMU_TSTR) | TMU_STR1));
}

/*
 *	Х󥿥ޤ߽
 *
 *	ޤưߤ롥
 */
OVRTIM
target_ovrtimer_stop(void)
{
    OVRTIM rest;

    /* ޤ */
    sil_wrb_mem((void*)TMU_TSTR,
                (sil_reb_mem((void*)TMU_TSTR) & ~TMU_STR1));
    /* ׵򥯥ꥢ */
    sil_wrh_mem((void*)TMU_TCR1,
                (sil_reh_mem((void*)TMU_TCR1) & ~TCR_UNF));

	rest = (OVRTIM)sil_rew_mem((void*)TMU_TCNT1);

    if(rest < 0){
        return 1;
    } else {
        return (OVRTIMER_USEC(rest + 1));
    }
}

/*
 *	Х󥿥ޤλĤ֤ɽФ
 */
OVRTIM
target_ovrtimer_get_current(void)
{
    OVRTIM rest;

	rest = (OVRTIM)sil_rew_mem((void*)TMU_TCNT1);

    if(rest < 0){
        return 0;
    } else {
        return (OVRTIMER_USEC(rest + 1));
    }
}

/*
 *	Х󥿥޳ߥϥɥ
 */
void
target_ovrtimer_handler(void)
{
    /* ׵򥯥ꥢ */
    sil_wrh_mem((void*)TMU_TCR1,
                (sil_reh_mem((void*)TMU_TCR1) & ~TCR_UNF));

	i_begin_int(INTNO_OVRTIMER);
	call_ovrhdr();
	i_end_int(INTNO_OVRTIMER);
}

#endif /* TOPPERS_TARGET_SUPPORT_OVRHDR */

