/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2007-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_timer.h 1598 2009-06-29 09:43:33Z ertl-honda $
 */

/*
 *  ޥɥ饤СSOI-SOCѡ
 */

#ifndef TOPPERS_TARGET_TIMER_H
#define TOPPERS_TARGET_TIMER_H

/*
 *  ͤɽ msec ñ̤ȤѴ
 *  SOI-SOCǤϡPå30MHz
 *  ʬ /4,/16,/64/256 Τ줫
 *  /4  : 7.500MHz tick 7500
 *  /16 : 1.875MHz tick 1875
 *  /64 : 0.469MHz tick  469(0.46875)
 *  /256: 0.117MHz tick  117(0.1171875)
 *
 *  /16 
 */

#define TCR0_TPSC  0x0001

/*
 *  ͤɽȥߥñ̤ȤѴ
 */
#define TIMER_CLOCK 1875

/*
 * ץå¸
 */ 
#include "sh34_gcc/prc_timer.h"

#ifdef TOPPERS_TARGET_SUPPORT_OVRHDR
/*
 *  TMU_CMT1Ѥ
 */

/*
 *	޳ߥϥɥϿΤ
 */
#define INHNO_OVRTIMER 	TMU1_INTEVT   /* ߥϥɥֹ */
#define INTNO_OVRTIMER 	TMU1_INTEVT   /* ֹ */
#define INTPRI_OVRTIMER	(-7)		  /* ͥ */
#define INTATR_OVRTIMER	0U			  /* ° */

#endif /* TOPPERS_TARGET_SUPPORT_OVRHDR */

#ifndef TOPPERS_MACRO_ONLY
#ifdef TOPPERS_TARGET_SUPPORT_OVRHDR
/*
 *	ͤɽȥޥñ̤ȤѴ
 *	1secΥåȿ
 */
#define OVRTIMER_CLOCK(usec) ((usec) * TIMER_CLOCK / 1000)
#define OVRTIMER_USEC(clock) ((clock) * 1000 / TIMER_CLOCK)

/*
 *	Х󥿥ޤν
 *
 *	ޤ롥
 */
extern void target_ovrtimer_initialize(intptr_t exinf);

/*
 *	Х󥿥ޤνλ
 *
 *	ޤưλ롥
 */
extern void target_ovrtimer_terminate(intptr_t exinf);

/*
 *	Х󥿥ޤεư
 *
 *	ޤư롥
 */
extern void target_ovrtimer_start(OVRTIM ovrtim);

/*
 *	Х󥿥ޤ߽
 *
 *	ޤưߤ롥
 */
extern OVRTIM target_ovrtimer_stop(void);

/*
 *	Х󥿥ޤθͤɽФ
 */
extern OVRTIM target_ovrtimer_get_current(void);

/*
 *	Х󥿥޳ߥϥɥ
 */
extern void target_ovrtimer_handler(void);

/*
 *  Хϥɥ鵯ư롼
 */
extern void	call_ovrhdr(void);

#endif /* TOPPERS_TARGET_SUPPORT_OVRHDR */
#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_TARGET_TIMER_H */
